import swarm.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.Selector;
import swarm.space.*;
import swarm.collections.*;

public class Model extends SwarmImpl{
	double x,y;
	
	public int worldXSize, worldYSize;
	public double fishDensity;
	public double predatorDensity;
	
	SeaSpace sea;
	Grid2d world;
	Grid2d world2;
	
	List fishList;
	List predatorList;
	ActionGroup modelActions;
	Schedule modelSchedule;
	
	public Model(Zone aZone){
		super(aZone);
		
		//őp[^̐ݒ
		worldXSize=160;
		worldYSize=160;
		fishDensity=0.008;
		//predatorDensity=0.001; //56~62sڂgȂKv
	}
	
	public Object buildObjects(){
		Predator aPredator;
		Fish aFish;
		int x,y;
		
		sea=new SeaSpace(this,worldXSize,worldYSize);
		
		world=new Grid2dImpl(this,worldXSize,worldYSize);
		world.fillWithObject(null);
		
		world2=new Grid2dImpl(this,worldXSize,worldYSize);
		world2.fillWithObject(null);
		
		fishList=new ListImpl(this);
		predatorList = new ListImpl(this);
		
		for (y = 0; y < worldYSize; y++){
			for (x = 0; x < worldXSize; x++){
				/* predatorDeinstyɏ]predator𐔕Cꍇ
				if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < predatorDensity){
					aPredator=new Predator(this);
					aPredator.setWorld(world2);
					aPredator.setX$Y(x,y);
					predatorList.addLast(aPredator);
				}*/
				/* predator𒆐S2Cꍇ
				if((x==(int)worldXSize/2 && y==(int)worldYSize/2) || (x==(int)worldXSize/2+1 && y==(int)worldYSize/2+1)){
					aPredator=new Predator(this);
					aPredator.setWorld(world2);
					aPredator.setX$Y(x,y);
					predatorList.addLast(aPredator);
				}*/
				/* predator𒆐S1Cꍇiꂪ₷j */
				if(x==(int)worldXSize/2 && y==(int)worldYSize/2){
					aPredator=new Predator(this);
					aPredator.setWorld(world2);
					aPredator.setX$Y(x,y);
					predatorList.addLast(aPredator);
				}
				if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < fishDensity){
					aFish=new Fish(this);
					aFish.setWorld(world);
					aFish.setX$Y(x,y);
					fishList.addLast(aFish);
				}
			}
		}
		return this;
	}

	public Object buildActions(){
		modelActions=new ActionGroupImpl(this);
		//predator܂
		try{
			modelActions.createActionForEach$message(predatorList,new Selector(Class.forName("Predator"),"step",false),fishList);
		} catch (Exception e) {
			e.printStackTrace (System.err);
			System.exit(1);
		}
		//predatorObjectxSCuȂ
		for(int i=0;i<worldXSize;i++){
			for(int j=0;j<worldYSize;j++){
				world2.putObject$atX$Y(null,i,j);
			}
		}
		try{
			modelActions.createActionForEach$message(predatorList,new Selector(Class.forName("Predator"),"putSelfOn",false));
		} catch (Exception e) {
			e.printStackTrace (System.err);
			System.exit(1);
		}
		//fisḧʒupredator玀S
		try{
			modelActions.createActionForEach$message(fishList,new Selector(Class.forName("Fish"),"liveordie",false),predatorList);
		} catch (Exception e) {
			e.printStackTrace (System.err);
			System.exit(1);
		}
		//fish𓮂
		try{
			modelActions.createActionForEach$message(fishList,new Selector(Class.forName("Fish"),"step",false),fishList,predatorList);
		} catch (Exception e) {
			e.printStackTrace (System.err);
			System.exit(1);
		}
		//fishObjectxSCuȂ
		for(int i=0;i<worldXSize;i++){
			for(int j=0;j<worldYSize;j++){
				world.putObject$atX$Y(null,i,j);
			}
		}
		try{
			modelActions.createActionForEach$message(fishList,new Selector(Class.forName("Fish"),"putSelfOn",false));
		} catch (Exception e) {
			e.printStackTrace (System.err);
			System.exit(1);
		}
		
		modelSchedule=new ScheduleImpl(this,1);
		modelSchedule.at$createAction(0,modelActions);
		return this;
	}
	
	public Activity activateIn(Swarm context){
    	super.activateIn (context);
    	modelSchedule.activateIn(this);
		return getActivity();
	}

	//Sfish̎񂾉񐔂Ƃo
	public void DeathCount(){
		int totaldeath=0;
		double deathrate=0;
		int loop=0;
		for(int i=0;i<fishList.getCount();i++){
			Fish aFish=(Fish)fishList.atOffset(i);
			totaldeath += aFish.die;
			deathrate+=(double)aFish.die/aFish.loop;
			loop=aFish.loop;
		}
		deathrate=deathrate*100/fishList.getCount();
		System.out.println("TotalDeath: "+totaldeath);
		System.out.println("Loop: "+loop);
		System.out.println("DeathRate: "+deathrate+"%");
	}

	public Grid2d getWorld(){
		return world;
	}
	
	public Grid2d getWorld2(){
		return world2;
	}
	
	public SeaSpace getSea(){
		return sea;
	}

	public List getFishList(){
		return fishList;
	}
	
	public List getPredatorList(){
		return predatorList;
	}
}